package de.pdw_express.parser.sged;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;

import de.ipk.pdwexpress.peobjects.PE_BIOMATERIALS;
import de.ipk.pdwexpress.peobjects.PE_BIOSEQUENCES;
import de.ipk.pdwexpress.peobjects.PE_EXPERIMENTS;
import de.ipk.pdwexpress.peobjects.PE_ExternDBEnum;
import de.ipk.pdwexpress.peobjects.PE_HYBRIDISATIONS;
import de.ipk.pdwexpress.upload.AbstractPEObject;
import de.ipk.pdwexpress.upload.ImportHandler;
import de.pdwexpress.parser.common.MatrixParser;

public class Import_87 {

	ImportHandler importHandler;
	Connection con;
	
	String dataFileName;
	String experimentFileName;
	String materialFileName;
	String hybridisationFileName;

	String experimentPK;
	ImportTools tool;


	
	
	
	
	
	public Import_87(ImportHandler importHandler,Connection con, String dataFileName, String experimentFileName, String materialFileName, String hybridisationFileName) {
		super();
		// TODO Auto-generated constructor stub
		this.importHandler = importHandler;
		this.con = con;
		this.dataFileName = dataFileName;
		this.experimentFileName = experimentFileName;
		this.materialFileName = materialFileName;
		this.hybridisationFileName = hybridisationFileName;
		
		experimentPK="not set yet";
		tool=new ImportTools(importHandler, con);
		
	}

	public void insertExperiment(String experiment_ID) throws IOException,NoSuchMethodException, ClassNotFoundException, SQLException, FileNotFoundException{
		String expObjKey=new String();
		try{
			MatrixParser<PE_EXPERIMENTS> ap = new MatrixParser<PE_EXPERIMENTS>(new PE_EXPERIMENTS());
			List<PE_EXPERIMENTS> myExp = ap.parseFile(new File(experimentFileName));
			for (PE_EXPERIMENTS ex:myExp ){
				ex.setOBJ_Identifier(experiment_ID, PE_ExternDBEnum.SGED);
				ex.saveObject();
				expObjKey=ex.getObj_id();
			}
		}catch (SQLException e){
			con.rollback();
			throw e;
		}
		experimentPK=expObjKey;
		
	}
	
	public Hashtable<String, String> insertHybridisations() throws SQLException,NoSuchMethodException,IOException{
		
		Hashtable<String, String> hybIDs=new Hashtable<String, String>();
		try{
			AbstractPEObject.setImportHandler(importHandler);
			MatrixParser<PE_HYBRIDISATIONS> ap = new MatrixParser<PE_HYBRIDISATIONS>(new PE_HYBRIDISATIONS());
			List<PE_HYBRIDISATIONS> myHyb = ap.parseFile(new File (hybridisationFileName));
			for (PE_HYBRIDISATIONS ex:myHyb){
				ex.setFK_HYB_ARY_ID(tool.insertArray());
				ex.saveObject();
				hybIDs.put(ex.getOBJ_Name(), ex.getObj_id());
			}
		}catch (SQLException e){
			con.rollback();
			throw e;
		}
		
		
		return hybIDs;
	}
		
	public Hashtable<String, String> insertMaterials()
	throws ClassNotFoundException, SQLException, FileNotFoundException, IOException, NoSuchMethodException{
		
		Hashtable<String, String> matIDs = new Hashtable<String, String>();
		try{
			AbstractPEObject.setImportHandler(importHandler);
			MatrixParser<PE_BIOMATERIALS> ap = new MatrixParser<PE_BIOMATERIALS>(new PE_BIOMATERIALS());
			List<PE_BIOMATERIALS> myExp = ap.parseFile(new File(materialFileName));
			for (PE_BIOMATERIALS ex:myExp ){
				ex.saveObject();
				matIDs.put(ex.getOBJ_Name(),ex.getObj_id());
			}
		}catch (SQLException e){
			con.rollback();
			throw e;
		}
		return matIDs;
	}
	
	public void insertData(Hashtable<String, String> matIDs, Hashtable<String, String> hybIDs)
		throws IOException, SQLException
	{
		
		/*
		 * get the conncetion between the hybs and the materials
		 */
		Hashtable<String, String> queryProbes= new Hashtable<String, String>();
		Hashtable<String, String> referenceProbes = new Hashtable<String, String>();
		
		BufferedReader in = new BufferedReader (new FileReader("D:/Import/SGED/87/bstupar_1_hyb.txt"));
		in.readLine();
		String inputline = in.readLine();
		while (inputline !=null){
			String[] splitline = inputline.split("\t");
			queryProbes.put(splitline[0], splitline[1].substring(0,7));
			referenceProbes.put(splitline[0], splitline[2].substring(0,7));
			inputline = in.readLine();
		}
		in.close();
		
		/*
		 * now read the file with the values
		 * 
		 * first get all hybs
		 */
		Vector<String>hybs = new Vector<String>();
		in = new BufferedReader ( new FileReader(dataFileName));
		inputline = in.readLine();
		String[] splitline = inputline.split("\t");
		for (int i=1; i<splitline.length; i=i+7){
			hybs.add(splitline[i]);
		}
		/*
		 * generate Resultsets
		 */
		Vector<ResultSet> rsets= new Vector<ResultSet>();
		for (Enumeration<String> myenum = hybs.elements();myenum.hasMoreElements();){
			String myhyb = myenum.nextElement();
			
			String hybFK       =hybIDs.get(myhyb);
			String mat1FK       = new String();
			String mat2FK       = new String();
			String queryMatFK  =matIDs.get(queryProbes.get(myhyb));
			String refMatFK    =matIDs.get(referenceProbes.get(myhyb));
			
			
			/*
			 * define labels
			 */
	
			int l=myhyb.length() ;
			if(myhyb.substring(l-1).equalsIgnoreCase("1")){
				mat1FK=queryMatFK;
				mat2FK=refMatFK;
				
			}else{
				mat1FK=refMatFK;
				mat2FK=queryMatFK;
				}
			
			
		
			
			int firstColumn= ((hybs.indexOf(myhyb)+1)*7)-6;
			
			System.out.println(myhyb+"   "+hybs.indexOf(myhyb)+"  "+firstColumn);
			ResultSet myrset=new ResultSet(
					con, hybFK, mat1FK, firstColumn, "Cy3");
			myrset.insert();
			rsets.add(myrset);
			myrset=new ResultSet(
					con, hybFK, mat2FK, firstColumn, "Cy5");
			myrset.insert();	
			rsets.add(myrset);
		}
		
		
		in.readLine();
		inputline = in.readLine();
		
		
		String mypst = " insert into result_data_t " +
		"(rsd_obj_id_rst, rsd_obj_id, rsd_value) values (?,?,?)";
			PreparedStatement pst= con.prepareStatement(mypst);
		
		
		while (inputline != null){
			splitline = inputline.split("\t");
			PE_BIOSEQUENCES seq = new PE_BIOSEQUENCES();
			seq.setOBJ_Identifier(splitline[0], PE_ExternDBEnum.SGED);
			seq.setOBJ_Name(splitline[0]);
			System.out.println(splitline[0]);
			String seqFK =seq.saveObject();

			
			for (Enumeration<ResultSet> myenum= rsets.elements();myenum.hasMoreElements();){
				ResultSet rs=myenum.nextElement();
				
				String value1 = splitline[rs.getFirstColumn()];
				String value2 = splitline[rs.getFirstColumn()+1];
				
				pst.setInt(1,Integer.parseInt(rs.fK) );
				pst.setInt(2, Integer.parseInt(seqFK));
				pst.setInt(3,Integer.parseInt( value1));
				pst.execute();
				
				pst.setInt(1,Integer.parseInt(rs.fK) );
				pst.setInt(2, Integer.parseInt(seqFK));
				pst.setInt(3,Integer.parseInt( value2));
				pst.execute();
				
				
			}
			
		inputline= in.readLine();	
			
		}
		
		
		
		
		pst.close();
		in.close();
	}
	
	
	
}
