package de.pdw_express.parser.sged;

import java.sql.SQLException;
import java.util.Hashtable;

import de.ipk.pdwexpress.peobjects.PE_HYBRIDISATIONS;
import de.ipk.pdwexpress.peobjects.PE_RESULTSETS;

/*
 * 
 * A TIGR Experiment is a collection of all technical replictates. Here it consists of two hybridisations
 * 
 */



public class TIGR_Experiment {

	String name;
	String bioReplicateNumber;
	int firstColumn;
	String tissue;
	String day;
	
	String testMaterialKey;
	String controlMaterialKey;
	
	String testLabel;
	String controlLabel;
	
	String hyb1_FK;
	String hyb2_FK;
	String res1_FK; //Hyb1 Cy3
	String res2_FK; //Hyb2 Cy5
	String res3_FK; //Hyb1 Cy3
	String res4_FK; //Hyb2 Cy5
	


	public void insertIntoDB(String Experiment_FK, Hashtable<String, String> matIDs)throws SQLException{
		
		
		/*
		 * save hybridisations
		 */
		PE_HYBRIDISATIONS hyb;
		int rep1;
		int repcounter;
		
		hyb= new PE_HYBRIDISATIONS();
		hyb.setOBJ_Name(name+"_1");
		rep1=((Integer.parseInt(day))/4)+1;
		repcounter=((Integer.parseInt(bioReplicateNumber))*2)-1;	
		hyb.setReplicateIndex(new Integer(rep1).toString()+"."+new Integer(repcounter).toString());
		hyb1_FK=hyb.saveObject();
		
		hyb= new PE_HYBRIDISATIONS();
		hyb.setOBJ_Name(name+"_1");
		rep1=((Integer.parseInt(day))/4)+1;
		repcounter=((Integer.parseInt(bioReplicateNumber))*2);	
		hyb.setReplicateIndex(new Integer(rep1).toString()+"."+new Integer(repcounter).toString());
		hyb2_FK=hyb.saveObject();		
		
		/*
		 * save ResultSets
		 */
		
		
		//mind the flip dye
		String treatment1=new String();
		String treatment2=new String();
		if(bioReplicateNumber.equalsIgnoreCase("3")!=true){
			treatment1="sd";
			treatment2="ld";
		}else{
			treatment1="ld";
			treatment2="sd";
		}
		
		
		
		PE_RESULTSETS rset;
		String matName;
		rset= new PE_RESULTSETS();
		rset.setNormalizationDescriptionType("lowess");
		rset.setLabelCompound("Cy3");
		rset.setResultSetType("NormalisedData");
		matName=day+treatment1+tissue;
		rset.setFK_RST_HYB_ID(hyb1_FK);
		rset.setFK_RST_MAT_ID(matIDs.get(matName));
		res1_FK=rset.saveObject();
		
		

		rset= new PE_RESULTSETS();
		rset.setNormalizationDescriptionType("lowess");
		rset.setLabelCompound("Cy3");
		rset.setResultSetType("NormalisedData");
		matName=day+treatment1+tissue;
		rset.setFK_RST_HYB_ID(hyb2_FK);
		rset.setFK_RST_MAT_ID(matIDs.get(matName));
		res2_FK=rset.saveObject();
		

		rset= new PE_RESULTSETS();
		rset.setNormalizationDescriptionType("lowess");
		rset.setLabelCompound("Cy5");
		rset.setResultSetType("NormalisedData");
		matName=day+treatment2+tissue;
		rset.setFK_RST_HYB_ID(hyb1_FK);
		rset.setFK_RST_MAT_ID(matIDs.get(matName));
		res3_FK=rset.saveObject();
		

		rset= new PE_RESULTSETS();
		rset.setNormalizationDescriptionType("lowess");
		rset.setLabelCompound("Cy5");
		rset.setResultSetType("NormalisedData");
		matName=day+treatment2+tissue;
		rset.setFK_RST_HYB_ID(hyb2_FK);
		rset.setFK_RST_MAT_ID(matIDs.get(matName));
		res4_FK=rset.saveObject();
		
	
		
		
		
		
		
		
		
	}






	public String getBioReplicateNumber() {
		return bioReplicateNumber;
	}






	public void setBioReplicateNumber(String bioReplicateNumber) {
		this.bioReplicateNumber = bioReplicateNumber;
	}






	public String getControlLabel() {
		return controlLabel;
	}






	public void setControlLabel(String controlLabel) {
		this.controlLabel = controlLabel;
	}






	public String getControlMaterialKey() {
		return controlMaterialKey;
	}






	public void setControlMaterialKey(String controlMaterialKey) {
		this.controlMaterialKey = controlMaterialKey;
	}






	public String getDay() {
		return day;
	}






	public void setDay(String day) {
		this.day = day;
	}






	public int getFirstColumn() {
		return firstColumn;
	}






	public void setFirstColumn(int firstColumn) {
		this.firstColumn = firstColumn;
	}






	public String getName() {
		return name;
	}






	public void setName(String name) {
		this.name = name;
	}






	public String getTestLabel() {
		return testLabel;
	}






	public void setTestLabel(String testLabel) {
		this.testLabel = testLabel;
	}






	public String getTestMaterialKey() {
		return testMaterialKey;
	}






	public void setTestMaterialKey(String testMaterialKey) {
		this.testMaterialKey = testMaterialKey;
	}






	public String getTissue() {
		return tissue;
	}






	public void setTissue(String tissue) {
		this.tissue = tissue;
	}






	public String getRes1_FK() {
		return res1_FK;
	}






	public String getRes2_FK() {
		return res2_FK;
	}






	public String getRes3_FK() {
		return res3_FK;
	}






	public String getRes4_FK() {
		return res4_FK;
	}
	
}



