package de.pdwexpress.parser.afgc_atgenexpress;

import java.util.LinkedHashMap;
import java.util.Iterator;
import java.io.FileWriter;
import java.io.IOException;

/**
 * This class generates a file with ExpressionSet_XXX directories. This generated file
 * can be used for an import. Directories (ExpressionSets), which shall not be imported
 * can be deleted from the file or uncommented by a leading sharp-sign.
 *
 * @author Andreas Stephanik
 */
public class DirFileGenerator {


    public static final String expr_set_dir_file = "expression_set_dirs.txt";


    public static void main(String[] args) {
        if(args.length != 1) {
            System.out.println("Usage:\tjava DirFileGene <parent_dir>");
        }
        LinkedHashMap<String, String[]> dirs = AFGC_AtGenExpress_ImportController.getExpressionSetDirectoriesAndFileNames(args[0]);
        if(dirs != null) {
            String dir;
            try {
                FileWriter fw = new FileWriter(expr_set_dir_file);
                for(Iterator<String> it = dirs.keySet().iterator(); it.hasNext(); ) {
                    fw.write(it.next() + "\n");
                }
                fw.close();
            }
            catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
